#include <unistd.h>
#include <stdio.h>
#include <termios.h>
#include <fcntl.h>
#include <sys/ioctl.h>

#define	TTY	"/dev/tty"

/* Issue prompt and read reply with echo turned off */
char *getpass(const char * prompt)
{
	struct termios ttyb,ttysav;
	char *cp;
	int c;
	FILE *tty;
	static char pbuf[128];

#ifndef BEBOX
	if ((tty = fdopen(open(TTY, O_RDWR), "r")) == NULL)
#endif /* !BEBOX */
		tty = stdin;
#ifndef BEBOX
	else
		setbuf(tty, (char *)NULL);
#endif /* !BEBOX */

	ioctl(fileno(tty), TCGETA, &ttyb);
	ioctl(fileno(tty), TCGETA, &ttysav);

	ttyb.c_lflag &= ~(ECHO|ISIG);
	ioctl(fileno(tty), TCSETA, &ttyb);

	fflush(stdout);
	fprintf(stderr, "%s", prompt);
	fflush(stderr);

	cp = pbuf;
	for (;;) {
		c = getc(tty);
		if(c == '\r' || c == '\n' || c == EOF)
			break;
		if (cp < &pbuf[127])
			*cp++ = c;
	}
	*cp = '\0';

	fprintf(stderr,"\r\n"); fflush(stderr);

	ioctl(fileno(tty), TCSETA, &ttysav);
	if (tty != stdin)
		fclose(tty);

	return(pbuf);
}
